import java.util.LinkedHashMap;

/**
 * Lab #5
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * Each object of this class represents a state.
 * </p>
 * @version 1.0
 *
 */
public class State {
	// TODO:  Make this class serializable

	private String name;
	private LinkedHashMap<String, City> cityMap;

	public State (){
		this.name = "";
		this.cityMap = new LinkedHashMap<String, City>();
	}
	
	public State (String name) {
		this.name = name;
		this.cityMap = new LinkedHashMap<String, City>();
	}

	/**
	 * @param name
	 * @param cityMap
	 */
	public State(String name, LinkedHashMap<String, City> cityMap) {
		this.name = name;
		this.cityMap = cityMap;
	}

	/**
	 * @return the state name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name of the state to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return an array of the cities in the cityMap
	 */
	public City[] getCityArray() {
		City[] templateCityArray = new City[1];
		return cityMap.values().toArray(templateCityArray);
	}

	/**
	 * @param cityMap the collection of cities to set
	 */
	public void setCityMap(LinkedHashMap<String, City> cityMap) {
		this.cityMap = cityMap;
	}
	
	/**
	 * @param name the name of the city to look for in the collection
	 * @return true if the city name is already in the collection, false otherwise
	 */
	public boolean contains(String name) {
		return this.cityMap.containsKey(name);
	}
	
	/**
	 * @param name the name of the city to look for in the collection
	 * @return the found city converted to a String
	 */
	public String getCityString(String name) {
		return this.cityMap.get(name).toString();
	}
	
	/**
	 * @param city to add to the cityMap
	 * 
	 * If the city is NOT in the city collection, it can be added.
	 */
	public boolean addCity(City city) {
		if (!this.cityMap.containsKey(city.getName())){
			this.cityMap.put(city.getName(), city);
			return true;
		}
		else {
			return false;
		}
	}
	
	/**
	 * @param city the city to replace in the cityMap 
	 * 
	 * If the city IS in the city collection, it can be replaced.
	 */
	public boolean replaceCity(City city) {
		if (this.cityMap.containsKey(city.getName())){
			this.cityMap.put(city.getName(), city);
			return true;
		}
		else {
			return false;
		}
	}
	
	/**
	 * Clears the collection of city
	 */
	public void clearCities() {
		this.cityMap = new LinkedHashMap<String, City>();
	}
	
	// TODO:  Add methods for object input and output
	// These should load and save the entire State object
	// Model these after the object IO routines of Lab 4
	// "Hard code" the name of the data file for this to be "Oklahoma.dat"
	
	// TODO:  Add method for printing to the console
	// This should print all data of the State object to the console
	// The formatting is up to you but should be intuitive to the grader
}