import java.awt.event.*;

/**
 * Lab #5 CS 2334, Section SECTION NUMBER GOES HERE DATE GOES HERE
 * <p>
 * The MVC controller for the program.
 * </p>
 * 
 * @version 1.0
 * 
 */
public class StateController {
	private StateModel model;
	private StateInputWindow inputView;

	/**
	 * Creates new StateController
	 */
	public StateController() {
		// intentionally empty
	}

	/**
	 * AddCityListener provides a method to create a new city. The city
	 * should then be added to the city list of the model. The values for the
	 * new city come from the fields of the inputView. If the model is null
	 * when the method is called, it returns without taking any action.
	 */
	private class AddCityListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.

			String name = inputView.jtfName.getText();
			String latitude = inputView.jtfLatitude.getText();
			String longitude = inputView.jtfLongitude.getText();

			if (model.contains(name)) {  // City already in collection so ask what to do

				// TODO: Use a JOptionPane here to ask what to do 
				
				int response;  // assign returned value of JOptionPane to response

				if (response == 0) {
					// option 0 is cancel so do nothing
				}
				else if (response == 1) {
					// TODO: call mutator method to replace city (note that option 1 should be replace)
				}
				else {
					// Should handle error case here (we won't for this lab).
				}
			}
			else {  // City not in collection, so add
			}
		}
	}

	/**
	 * ClearCityListener provides a method to clear the city list of the
	 * model. If the model is null when the method is called, it returns without
	 * taking any action.
	 */
	private class ClearCityListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (model == null) return;  // No model associated.  Can't do anything.
			model.clearCities();
		}
	}

	/**
	 * ClearInputFieldsListener provides a method to clear the input fields of
	 * the inputView.
	 */
	private class ClearInputFieldsListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			inputView.clearInputFields();
		}
	}

	// TODO:  Create additional listener classes for menu and toolbar.

	/**
	 * @param model
	 * 			to set as the model
	 */
	public void setModel(StateModel model) {
		this.model = model;
	}

	/**
	 * @return StateModel the model
	 */
	public StateModel getModel() { // future use
		return model;
	}

	/**
	 * @param theView
	 *            on which the listeners should be set
	 */
	public void setInputWindow(StateInputWindow inputView) {
		this.inputView = inputView;

		// Register listeners
		this.inputView.getAddCityButton().addActionListener(new AddCityListener());
		this.inputView.getClearInputButton().addActionListener(new ClearInputFieldsListener());
		this.inputView.getClearCitiesButton().addActionListener(new ClearCityListener());

		// TODO: Register additional listeners for menu and toolbar.


		System.out.println("listeners registered in controller for input window");
	}

	/**
	 * @return the window (in case it needs to be sent messages from elsewhere)
	 */
	public StateInputWindow getInputWindow() { // future use
		return inputView;
	}
}