import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 * Lab #5
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * Each object of this class represents a GUI display window (MVC view).
 * </p>
 * @version 1.0
 *
 */
public class StateDisplayWindow extends JFrame implements ActionListener {
	private static final long serialVersionUID = -7544472247240102278L;
	
	private JList<City> displayCityList;
	private StateModel model;
	
	public StateDisplayWindow() {
		setTitle("Cities in OK");
	}

	public void actionPerformed(ActionEvent e) {
		displayCityList.setListData(model.getCityArray());
		pack();
	}
	
	public void setModel(StateModel model) {
		this.model = model;
		
		if (model != null) {
			model.addActionListener(this);
			add(new JLabel("CITY NAME, STATE (LATITUDE, LONGITUDE)"), BorderLayout.NORTH);
			displayCityList = new JList<City>(model.getCityArray());
			add(displayCityList, BorderLayout.CENTER);
			pack();
			setVisible(true);
		}
	}

	public StateModel getModel() {
		return model;
	}
}